----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/26/2018 01:05:37 PM
-- Design Name: 
-- Module Name: game_of_life - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity game_of_life is
    Port (
        clk_sys : in STD_LOGIC
    );
end game_of_life;

architecture Behavioral of game_of_life is

component clk_wiz_0
port
 (-- Clock in ports
  -- Clock out ports
  clk_25MHz_out          : out    std_logic;
  -- Status and control signals
  locked            : out    std_logic;
  clk_in1           : in     std_logic
 );
end component;

component one_second_clock
port
  (
    clock_in : in STD_LOGIC;
    locked : in STD_LOGIC;
    clock_out : out STD_LOGIC
  );
end component;

component cell
port
 (
   clk_1hz : in STD_LOGIC;
   locked : in STD_LOGIC;
   switch : in STD_LOGIC;
   flip_val : inout STD_LOGIC;
   neighbours : in STD_LOGIC_VECTOR(1 to 8);
   output : out STD_LOGIC
 );
end component;

signal locked, inner_clk, one_sec_clk : STD_LOGIC;

-- the cell_outputs signal holds the output of the cells
-- the 0th element holds the boundary condition
-- we have 64×48 cells
signal cell_outputs : STD_LOGIC_VECTOR(0 to 3072);

begin

tic_toc : clk_wiz_0
   port map ( 
  -- Clock out ports  
   clk_25MHz_out => inner_clk,
  -- Status and control signals                
   locked => locked,
   -- Clock in ports
   clk_in1 => clk_sys
 );
 
one_hertz_gen : one_second_clock
  port map 
  (
    clock_in => inner_clk,
    locked => locked,
    clock_out => one_sec_clk
);
 
synchron : process(inner_clk)
begin
    --
end process;

end Behavioral;
